//First Author: A.Vinci (mercurio@altrove.cjb.net)
//Second Author: Kornel Misiejuk (lenrock@2p.pl)
//Third Author: BatBat (fbat76@yahoo.fr)

 const NS_PROCESS_CONTRACTID    = "@mozilla.org/process/util;1"
 const NS_LOCAL_FILE_CONTRACTID = "@mozilla.org/file/local;1";
 const nsIFile            			= Components.interfaces.nsIFile;
 const nsILocalFile       			= Components.interfaces.nsILocalFile;
 const C                 			  = Components;
 
 HTTRACK_PATH = getFFUserDir("\\extensions\\{3cd27e92-1a30-11da-94c6-00e08161165f}\\httrack\\") + "httrack.exe";
 const DIRSEPARATOR 	= "\\";
 const TOTAL_DECKS 		= 2;

//for locale string bundle -> access to spiderzilla.properties
function getString(stringName){
	return document.getElementById("spiderstrings").getString(stringName);
}

//Am I a loafer ?
function getValue(id) {
	return document.getElementById(id).value;
}
function getChecked(id) {
	return document.getElementById(id).checked;
}
function el(id) {
	return document.getElementById(id);
}

//This function change window's content. 
//I use "stack" since "deck" doesn't work on 0.9.9
function showDeck(Index) {
	for(var n=0; n<TOTAL_DECKS; n++)
		el("deck-"+n).collapsed=1;
	el("deck-"+Index).collapsed=0;
}

//Contestual help for Action menu
function setActionHelp() {
	var res= "actionhelp" + document.getElementById("MlActionList").value;
	document.getElementById("DActionHelp").value = getString(res);
}

//Init the program
function startProgram() {
	if(window.arguments)
	   el("TbWebAddresses").value = window.arguments[0];
	if(!el("TbBaseDir").statusText)
    el("TbBaseDir").statusText = getString("StandardDir");
	el("TbBaseDir").value = el("TbBaseDir").statusText;
	if(!el("TbProxySet").statusText)
    el("TbProxySet").statusText = getString("StandardProxy");
	el("TbProxySet").value = el("TbProxySet").statusText;
  
	for(var n = 1; n<=10;n++) {
		el("MlExternalDepth").appendItem ( n ,n); 
		el("MlDepth").appendItem ( n ,n);
		el("MlNrRetries").appendItem ( n ,n);
	}
	setActionHelp();
}

function exitProgram(){
   el("TbBaseDir").statusText = el("TbBaseDir").value;
   el("TbProxySet").statusText = el("TbProxySet").value;
   window.close()
}

//Other
function selectBaseFolder() {
	const nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	var baseDirBundle=getString("baseDir");
	fp.init(window, baseDirBundle, nsIFilePicker.modeGetFolder);
	
	if (fp.show() == nsIFilePicker.returnOK) {
		var path = fp.file.path;
		document.getElementById("TbBaseDir").value = path;
	}
	el("TbBaseDir").statusText = el("TbBaseDir").value;
}

function executeFile(executable, args) {
  dump(getString("execFile")+" ("+args.length+")\n"+executable.path+" "+args.join(" ")+"\n");

  if (!executable.exists()) {
    alert(getString("execFile")+":\n"+getString("execFile2")+"\n'"+executable.path+"'");
    return false;
  }
  try {
    var process = Components.classes[NS_PROCESS_CONTRACTID].createInstance(Components.interfaces.nsIProcess);

    process.init(executable);

    var pid = new Object();
    process.run(false, args, args.length, pid);
    
  }
  catch (ex) {
    dump(getString("execFile3")+" '"+executable.path+"'\n");
    return false;
  }
  return true;
}

//function getChromeDir(subdir) {
//	var dir   = new C.Constructor("@mozilla.org/file/directory_service;1", "nsIProperties");
//    rv        = (new dir()).get("AChrom", C.interfaces.nsIFile).path;
//	return  rv + subdir;
//}

function getFFUserDir(subdir) {
	var dir   = new C.Constructor("@mozilla.org/file/directory_service;1", "nsIProperties");
    rv        = (new dir()).get("ProfD", C.interfaces.nsIFile).path;
	return  rv + subdir;
}

//Builds command line 
function startDownload(){
	
	if (!getValue("TbProjectName")){
		alert(getString("projectName"));
		return;
	}
	if (!getValue("TbWebAddresses")){
		alert(getString("webUrl"));
		return;
	}
	if (!getValue("TbBaseDir")){
		alert(getString("baseDir"));
		return;
	}
	
	var param = new Array;
	var i=0;
  
	if (getValue("MlActionList").value) {
		var mir=0;
		var wizd=1;
		var sep=2;
		var mirlin=3;
		var testlin=4;
		var skel=5;
		var conti=6;
		var updat=7;
	
		if (getValue("MlActionList") == mir)
			param[i++] = "--mirror";
		if (getValue("MlActionList") == wizd)
			param[i++] = "--mirror-wizard";
		if (getValue("MlActionList") == sep)
			param[i++] = "--get-files";
		if (getValue("MlActionList") == mirlin)
			param[i++] = "--mirrorlinks";
		if (getValue("MlActionList") == testlin)
			param[i++] = "--spider";
		if (getValue("MlActionList") == skel)
			param[i++] = "--skeleton";
		if (getValue("MlActionList") == conti)
			param[i++] = "--continue";
		if (getValue("MlActionList") == updat)
			param[i++] = "--update";
	}

	param[i++] = getValue("TbWebAddresses"); 
	param[i++] = "-O" ;
	param[i++] = getValue("TbBaseDir") +DIRSEPARATOR + getValue("TbProjectName");
	
	if (getValue("TbProxySet")) {						//proxy ?
		param[i++] = "-P" ;
		param[i++] = getValue("TbProxySet") + ":" +getValue("TbProxyPort");
	}

	//Rules**********************************************************
	 if (getValue("MlDepth"))
		param[i++] = "-r" + getValue("MlDepth");
	 if (getValue("MlExternalDepth"))
		param[i++] = "-%e" + getValue("MlExternalDepth");
	 if (getValue("TbMaxNonHTMLSize")) {
		param[i++] = "-m" + getValue("TbMaxNonHTMLSize");
		if (getValue("TbMaxHTMLSize"))
			param[i-1] = param[i-1]+ "," + getValue("TbMaxHTMLSize");
	 }
	 if (getValue("TbMaxSiteSize"))
		param[i++] = "-M" + getValue("TbMaxSiteSize");
	 if (getValue("TbMaxTime"))
		param[i++] = "-E" + getValue("TbMaxTime");
	 if (getValue("TbMaxTransRate"))
		param[i++] = "-A" + getValue("TbMaxTransRate");
	 if (getValue("TbMaxConBySec"))
		param[i++] = "-%c" + getValue("TbMaxConBySec");
	 if (getValue("TbMaxPause"))
		param[i++] = "-G" + getValue("TbMaxPause");
	//Flow***********************************************************
	 if (getValue("TbNrMultiCon"))
		param[i++] = "-c" + getValue("TbNrMultiCon");
	 if (getValue("TbTimeOut"))
		param[i++] = "-T" + getValue("TbTimeOut");
	 if (getValue("MlNrRetries"))
		param[i++] = "-R" + getValue("MlNrRetries");
	 if (getValue("TbMinTransRate"))
		param[i++] = "-J" + getValue("TbMinTransRate");
	 if (getValue("HostControl"))
		param[i++] = "-H" + getValue("HostControl");
	//Links Option***************************************************
	 if (getChecked("CbExParsing"))
		param[i++] = "-%P0" ;
	 if (getChecked("CbGetNear"))
		param[i++] = "-n" ;
	 if (getChecked("CbTestURL"))
		param[i++] = "-t" ;
	//Spider Option**************************************************
	 if (getChecked("CbCookies"))
		param[i++] = "-b0" ;
	 if (getChecked("CbParsing"))
		param[i++] = "-j0" ;
	 if (getChecked("CbForceHTTP"))
		param[i++] = "-%h" ;
	 if (getChecked("CbKeepAlive"))
		param[i++] = "-%k" ;
	 if (getChecked("CbTolerReq"))
		param[i++] = "-%B" ;
	 if (getChecked("CbUpHacks"))
		param[i++] = "-%s" ;
	//Expert Option**************************************************
	 if (getChecked("CbSameDir"))
		param[i++] = "-S" ;
	 if (getChecked("CbGoUp"))
		param[i++] = "-U" ;
	 if (getChecked("CbGoDown"))
		param[i++] = "-D" ;
	 if (getChecked("CbGoBoth"))
		param[i++] = "-B" ;
	 if (getChecked("CbSameAddress"))
		param[i++] = "-a" ;
	 if (getChecked("CbSamePrin"))
		param[i++] = "-d" ;
	 if (getChecked("CbSameTLD"))
		param[i++] = "-l" ;
	 if (getChecked("CbGoEvery"))
		param[i++] = "-e" ;
	 if (getChecked("CbDebugHead"))
		param[i++] = "-%H" ;

	//LoG Index Cache************************************************
	 if (getChecked("CbNoCache"))
		param[i++] = "-C0" ;
	 if (getChecked("CbStoreAllCache"))
		param[i++] = "-k" ;
	 if (getChecked("CbNotReDown"))
		param[i++] = "-%n" ;
	 if (getChecked("CbDisplay"))
		param[i++] = "-%v" ;
	 if (getChecked("CbNoLog"))
		param[i++] = "-Q" ;
	 if (getChecked("CbQuiet"))
		param[i++] = "-q" ;
	 if (getChecked("CbLogExtraInfo"))
		param[i++] = "-z" ;
	 if (getChecked("CbLogDebug"))
		param[i++] = "-Z" ;
	 if (getChecked("CbLogOnScreen"))
		param[i++] = "-v" ;
	 if (getChecked("CbOneLogFile"))
		param[i++] = "-f2" ;
	 if (getChecked("CbNoIndex"))
		param[i++] = "-I0" ;
	 if (getChecked("CbSearchIndex"))
		param[i++] = "-%I" ;
	
	//Build Options**************************************************
 	 if(getValue("MlLongName"))
		param[i++] = "-L" + getValue("MlLongName");
	 if(getValue("MlK")) {
		var kwart="1"
		if(getValue("MlK") == kwart)
			param[i++] = "-K" ;
		if(getValue("MlK") != kwart)
			param[i++] = "-K" + getValue("MlK");
	 }
	 if (getChecked("CbRepExt"))
		param[i++] = "-x" ;
	 if (getChecked("CbNotQueryString"))
		param[i++] = "-%q0" ;
	 if (getChecked("CbGenError"))
		param[i++] = "-o0" ;
	 if (getChecked("CbKeepDel"))
		param[i++] = "-X0" ;
	 if (getChecked("CbASIS"))
		param[i++] = "-%p" ;
	
	//System********************************************************
	 if (getChecked("CbMozUA")) {
		param[i++] = "-F"  ;
		param[i++] = navigator.userAgent ;
	 }
	 
	//Filters********************************************************
	 var stringbuff = ""; //Get filters
	 if (getChecked("CbImages"))
		stringbuff+="+*.gif +*.jpg +*.jpeg +*.gif +*.bmp +*.png";
	 if (getChecked("CbArchives"))
		stringbuff+="+*.zip +*.rar +*.tgz +*.gz +*.rar";
	 if (getChecked("CbMedia"))
		stringbuff+="+*.mov +*.mpg +*.mpeg +*.mp3 +*.avi +*.asf";
	 stringbuff+=getValue("TbRules");
	 var ss = stringbuff.split(" ");
	 for (var n=0; n<ss.length; n++)
		param[i++] = ss[n];

	var httrack = Components.classes[NS_LOCAL_FILE_CONTRACTID].createInstance(nsILocalFile);
  httrack.initWithPath(HTTRACK_PATH);
	executeFile(httrack,param);
}

// loads a help page -- needs to be passed a case-variable 'whichPage'
function loadHelpPage(whichPage) {
	var pageUrl;
    
	switch(whichPage) {
		case "Homepage": 
			pageUrl = getString("spiderzilla.Homepage");
			break;
    case "SecondHomepage":
      pageUrl = getString("spiderzilla.SecondHomepage");
      break;
		case "httrackHomepage":
			pageUrl = getString("spiderzilla.httrackHomepage");
      break;
	}
	// --- --- --- // 
	var windowService = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
	var currentWindow = windowService.getMostRecentWindow("navigator:browser");
    if (currentWindow) {
		try {
		  currentWindow.delayedOpenTab(pageUrl);
		} catch(e) {currentWindow.loadURI(pageUrl); }
	}
	else
		window.open(pageUrl);
}

